/******************************************************************************/
/* AVR101 "ϋvEEPROML"												  */
/*																			  */
/* ̧ٖ	: High_Endurance_EEPROM.c										  */
/* t		: 2002N815													  */
/* 		: jllassen														  */
/*																			  */
/* ύX		: 2003N106 (raapeland)										  */
/* ύX		: 2006N718 (raapeland)										  */
/*																			  */
/* ߲	: IAR EWAVR 2.26C, IAR EWAVR 4.12A								  */
/******************************************************************************/

#include <iom16.h>

/******************************************************************************/
/* ɏՕ̒iK`														  */
/* - 8iK800,000Ұ݂ۏ؂܂B							  */
/******************************************************************************/
#define EE_PARAM_BUFFER_SIZE	8
#define EE_STATUS_BUFFER_SIZE	EE_PARAM_BUFFER_SIZE

/******************************************************************************/
/* װҰ̈ꗗ															  */
/******************************************************************************/
#define EE_PARAM_1		0
#define EE_PARAM_2		(EE_PARAM_1 + EE_PARAM_BUFFER_SIZE + EE_STATUS_BUFFER_SIZE)
//#define EE_PARAM_3	(EE_PARAM_2 + EE_PARAM_BUFFER_SIZE + EE_STATUS_BUFFER_SIZE) `Ȃ

/******************************************************************************/
/* g֐̌^錾														  */
/******************************************************************************/
void findCurrentEepromAddr( unsigned int *EeBufPtr );
char EeReadBuffer( unsigned int address );
void EeWriteBuffer( unsigned char parameter, unsigned int *address, unsigned char data );

/******************************************************************************/
/* Sϐ:																  */
/* ʒuōĊJ邱Ƃł悤ҰɏՕʒuwq		 .*/
/******************************************************************************/
unsigned int EeBufPtrParam1 = EE_PARAM_1; 
unsigned int EeBufPtrParam2 = EE_PARAM_2; 

void findCurrentEepromAddr( unsigned int *EeBufPtr )
{
	unsigned char temp;
	unsigned int EeBufEnd;

	*EeBufPtr += EE_PARAM_BUFFER_SIZE;				// ԊɏՕw
	EeBufEnd = *EeBufPtr + EE_STATUS_BUFFER_SIZE;	// ɏՕO̍ŏ̱ڽ

	/* ŌɏꂽԊɏՕ̗vf */
	do {
		temp = EeReadBuffer( *EeBufPtr );
		(*EeBufPtr)++;
		if (*EeBufPtr == EeBufEnd)					// ɏՕ̍Ō̏ꍇɒfÂɋEzr܂B
			break;
	} while (EeReadBuffer( *EeBufPtr ) == temp + 1);

	*EeBufPtr -= (EE_PARAM_BUFFER_SIZE + 1);		// ҰɏՕ̍ŌɎgvfw
}

char EeReadBuffer( unsigned int address )
{
	while(EECR & (1<<EEWE));
	EEAR = address;
	EECR |= (1<<EERE);
	return EEDR;
}

void EeWriteBuffer( unsigned char parameter, unsigned int *address, unsigned char data )
{
	unsigned char EeOldStatusValue;

	/* Ԓli[AʒuwqɏՕ̗̎vfֈړ */
	EeOldStatusValue = EeReadBuffer( *address + EE_PARAM_BUFFER_SIZE);
	(*address)++;
	if( *address == parameter + EE_PARAM_BUFFER_SIZE )
	{
		// KvȏꍇɊۂ
		*address = parameter;
	}

	// pŎ۸ݸނgꍇAEEPROMݑOɂǂ̎۸ݸ
	// Î҂悤ɂֺނ}ĂB܂ApŊ
	// ݂gꍇEEPROMݒɊ荞݂֎~邱Ƃm
	// BȂ΁A4𒴂邩܂B

	/* EEPROMɏՕҰXV */
	while(EECR & (1<<EEWE));
	EEAR = *address;
	EEDR = data;
	EECR |= (1<<EEMWE);
	EECR |= (1<<EEWE);

	/* ԊɏՕXV */
	while(EECR & (1<<EEWE));
	EEAR = *address + EE_PARAM_BUFFER_SIZE;
	EEDR = EeOldStatusValue + 1;
	EECR |= (1<<EEMWE);
	EECR |= (1<<EEWE);
}

/* EEPROMɏՕǂg邩 - pٰ */
void main ( void )
{
	unsigned char counter;

	findCurrentEepromAddr( &EeBufPtrParam1 );
	findCurrentEepromAddr( &EeBufPtrParam2 );

	for( counter = 0 ; counter < 50; counter++)
	{
		EeWriteBuffer( EE_PARAM_1, &EeBufPtrParam1, counter );
		EeWriteBuffer( EE_PARAM_2, &EeBufPtrParam2, counter*2 );
	}
}
